import ftplib
import socket
import logging
import os
import warnings
from collections import namedtuple
from tempfile import NamedTemporaryFile
from dateutil import parser
from itertools import islice

from imag_client.iaga2002 import split_iaga2002_fname, IagaData, MagSDSClient, is_gzipped, unzip_inplace

INTERMAG_FTP_SITE = 'ftp.seismo.nrcan.gc.ca'
FTP_CONNECTION_ERRORS = (
    OSError,
    ConnectionRefusedError,
    ftplib.error_reply,
    ftplib.error_perm,
    ftplib.error_proto,
    ftplib.error_temp,
)

FtpDirRequest = namedtuple('FtpDirRequest', ['year', 'month', 'sampling', 'd_type', 'ftp_directory'])

SAMPLE_RATES = ['minute', 'second']
DATA_QUALITIES = ['variation', 'provisional', 'quasi-definitive', 'definitive']


class InterMagFTPClient:

    def __init__(self, sds_root: str):
        self.sds_root = sds_root
        self.req_gen = InterMagRequestGenerator()
        pass

    def download_files_to_sds(self, *, full_path: str, fnames: [str]):

        with ftplib.FTP(INTERMAG_FTP_SITE) as ftp:
            _try_ftp_login(ftp)
            _try_ftp_cwd(ftp, full_path)

            for fname in fnames:
                logging.info(f"Retrieving {fname}")

                with NamedTemporaryFile(delete=False) as myfile:
                    myfilename = myfile.name
                    try:
                        ftp.retrbinary(f"RETR {fname}", myfile.write)
                    except (ftplib.error_perm, ftplib.error_proto, EOFError, OSError, socket.error) as err:
                        logging.warning(f"Error retrieving {fname} - caught {err}. Attempting to continue.")
                        os.remove(myfilename)
                        continue

                if is_gzipped(myfilename):
                    try:
                        unzip_inplace(myfilename)
                    except EOFError as err:
                        logging.warning(f'Unzipping problem with {fname}. Caught {err}.')

                try:
                    magdata = IagaData(myfilename, iaga_fname=fname)
                except UnboundLocalError as err:
                    logging.warning(f'Empty file {fname}. Caught {err}.')
                except ValueError as err:
                    logging.warning(f'Formatting problem encountered in file {fname}. Caught {err}.')
                else:
                    magdata.write_to_sds(self.sds_root)
                finally:
                    os.remove(myfilename)

    def download_single_file_to_sds(self, fname: str):
        self.download_files_to_sds(
            full_path=self.req_gen.req_from_iaga2002(fname=fname).ftp_directory,
            fnames=[fname]
        )

    def download_directory_to_sds(self, req: FtpDirRequest, fnames: [str] = None):
        """
        Retreives one month of data from the intermagnet ftp server and saves it as an SDS archive for obspy to read.
        :param req: An FTP request generated by generate_request
        :param fnames: An optional list of files to download. If not present, all the files in the directory are
        downloaded.
        :return:
        """
        warnings.warn('Use download_files_to_sds instead.', DeprecationWarning)

        required_fnames = _get_required_fnames(fnames, req, self.sds_root)
        full_path = req.ftp_directory
        self.download_files_to_sds(full_path=full_path, fnames=required_fnames)

    def get_filenames_on_ftp_site(self, *, req: FtpDirRequest):
        name_datestamps = self.get_ftp_filenames_and_datestamps(req=req)
        fname_list = [name for name, _ in name_datestamps]
        return fname_list

    @staticmethod
    def get_ftp_filenames_and_datestamps(*, req: FtpDirRequest):
        lines = []
        with ftplib.FTP(INTERMAG_FTP_SITE) as ftp:
            _try_ftp_login(ftp)
            _try_ftp_cwd(ftp, req.ftp_directory)
            ftp.dir('', lines.append)

        name_datestamps = []
        for line in lines:
            tokens = line.split(maxsplit=9)
            time_str = tokens[5] + " " + tokens[6] + " " + tokens[7]
            name_datestamps.append((tokens[8], parser.parse(time_str)))
        return name_datestamps


class InterMagRequestGenerator:

    def __init__(self):
        pass

    @staticmethod
    def generate_request(*, year: int, month: int, sampling: str, d_type: str):
        """
        Generates a request to download intermagnet data
        :param year: year
        :param month: month
        :param sampling: can be 'minute' or 'second'
        :param d_type: can be 'variation', 'quasi-definitive', 'provisional', 'definitive'. Defaults to 'variation'.

        :return: a FtpDirRequest that can be passed to intermagnet_to_sds
        """
        dirname = f'intermagnet/{sampling}/{d_type}/IAGA2002/{year}/{str(month).zfill(2)}'
        return FtpDirRequest(year, month, sampling, d_type, dirname)

    @staticmethod
    def requests_per_year_norestart(year):
        for month in range(12):
            for sampling in SAMPLE_RATES:
                for d_type in DATA_QUALITIES:
                    yield InterMagRequestGenerator.generate_request(
                        year=year,
                        month=month + 1,
                        sampling=sampling,
                        d_type=d_type,
                    )

    @staticmethod
    def requests_per_year(*, year: int, restart_after: FtpDirRequest = None):
        if restart_after is None:
            yield from InterMagRequestGenerator.requests_per_year_norestart(year)
        else:
            # find iteration number for restart_at request
            idx = 0
            for idx, req in enumerate(InterMagRequestGenerator.requests_per_year_norestart(year)):
                if req == restart_after:
                    break
            yield from islice(InterMagRequestGenerator.requests_per_year_norestart(year), idx + 1, None)

    @staticmethod
    def req_from_iaga2002(*, fname: str):
        station, year, month, _, type_string, samp_string = split_iaga2002_fname(fname)
        req = InterMagRequestGenerator.generate_request(
            year=int(year),
            month=int(month),
            sampling=samp_string,
            d_type=type_string
        )
        return req


def _try_ftp_login(ftp: ftplib.FTP):
    try:
        ftp.login()
    except ftplib.error_reply as err:
        raise ConnectionRefusedError(f"Could not log into ftp site. FTP error : {err}")


def _try_ftp_cwd(ftp: ftplib.FTP, path):
    try:
        ftp.cwd(path)
    except ftplib.error_perm as err:
        raise ResourceWarning(f"Requested path ({path}) does not exist on intermagnet ftp server."
                              f"FTP error : {err}")


def _get_required_fnames(fnames, req, sds_root):
    sds_client = MagSDSClient(sds_root=sds_root)
    # get the filenames if they are not already given
    if fnames is None:
        # fnames = get_filenames_on_ftp_site(ftp_site=INTERMAG_FTP_SITE, req=req)
        required_fnames = []
        for fname, timestamp in InterMagFTPClient(sds_root=sds_root).get_ftp_filenames_and_datestamps(req=req):
            if not sds_client.has_data_for_iaga2002_fname(fname):
                required_fnames.append(fname)
            elif timestamp > sds_client.get_sds_timestamp_for_iaga2002_fname(fname):
                required_fnames.append(fname)
    else:
        required_fnames = fnames
    return required_fnames


def ftp_up():
    try:
        with ftplib.FTP(INTERMAG_FTP_SITE) as ftp:
            ftp.login()
    except Exception as err:
        logging.warning(f'ftp_up() returns {err}')
        return False
    else:
        return True


def extract_iaga_filenames_from_file(fname: str):

    def contains_iaga_fname(some_string):
        return 'sec.sec' in some_string or 'min.min' in some_string

    def extract_iaga_fname(some_string):
        for word in some_string.split():
            if contains_iaga_fname(word):
                return word

    result = []
    with open(fname, 'r') as myfile:
        for line in myfile:
            if 'WARNING' in line and contains_iaga_fname(line):
                result.append(extract_iaga_fname(line))
    return result


def extract_last_finished_request(fname: str):

    def extract_parameters(string):
        word_dict = {}
        words = string.replace('(', ' ').replace(')', ' ').replace(',', '').replace('\'', '').split()
        for word in words:
            if '=' in word:
                key, value = word.split('=')
                word_dict[key] = value
        return word_dict

    with open(fname, 'r') as myfile:
        for line in myfile:
            if 'Finished request' in line:
                param_dict = extract_parameters(line)

    req = InterMagRequestGenerator.generate_request(
        year=int(param_dict['year']),
        month=int(param_dict['month']),
        sampling=param_dict['sampling'],
        d_type=param_dict['d_type'],
    )
    return req
